#pragma once
#include "DirectXFramework.h"
#include "SharedMethods.h"
#include "TexturedCubeNode.h"
#include "MeshNode.h"
#include "SplitMeshNode.h"
#include "TerrainNode.h"
#include <ctime>

enum class ControlInputs {Forward, Back, TurnLeft, TurnRight, StrafeLeft, StrafeRight, Up, Down, Fire1, Fire2};

class Graphics2 : public DirectXFramework
{
public:
	void CreateSceneGraph();
	void UpdateSceneGraph();

private:
	bool _boosting;
	float _boostMultiplier;

	float _flySpeed;
	float _turnSpeed;
	int _invertPitch;


	float _currentRotation = 0.0f;
	float _currentSideRotation = 0.0f;
	float _currentPropRotation = 0.0f;

	vector<ControlInputs> _currentInputs;

	void GetCurrentControlInputs();
	void ResetCurrentControlInputs();
};

