#pragma once
#include "DirectXFramework.h"

struct CBUFFER
{
	XMMATRIX    completeTransformation;
	XMMATRIX	worldTransformation;
	XMFLOAT4	cameraPosition;
	XMVECTOR    lightVector;
	XMFLOAT4    lightColor;
	XMFLOAT4    ambientColor;
	XMFLOAT4    diffuseCoefficient;
	XMFLOAT4	specularCoefficient;
	float		shininess;
	float		opacity;
	float       padding[2];
};

namespace SharedMethods
{
	XMMATRIX RotateFromPoint(float x, float y, float z, XMMATRIX rotationMatrix);

	float RGBValueToIntensity(int value);
	float lerp(int a, int b, int p);
	float lerp(float a, float b, float p);

};

